jQuery(function ($) {
    if ($('#mecom_airwallex_pay_for_order_page').length) {
        var mecom_checkout_form_airwallex = $('#order_review');
    } else {
        var mecom_checkout_form_airwallex = $('form.checkout');
    }

    function loadPaymentProcessAirwallex() {
        setTimeout(function () {
            if (!window.mecom_airwallex_checkout_error) {
                mecom_checkout_form_airwallex.removeClass('processing').unblock();
                $('#cs-airwallex-loader').show();
                setTimeout((function () {
                    $('#cs-airwallex-loader').hide();
                }), 30000);
            }
        }, 1000)
    }

    $(document).on('checkout_error_airwallex', function () {
        if ($('input[name="payment_method"]:checked').val() == 'mecom_airwallex') {
            $('#cs-airwallex-loader').hide();
            window.mecom_airwallex_checkout_error = true;
        }
    })
    $('body').on('click', '#place_order', function (e) {
        if ($('input[name="payment_method"]:checked').val() == 'mecom_airwallex') {
            window.mecom_airwallex_checkout_error = false;
            e.preventDefault();
            if (validateFormCheckoutAirwallex()) {
                if (window.paymentFormCompletedAirwallex) {
                    mecom_checkout_form_airwallex.submit()
                }
            } else {
                mecom_checkout_form_airwallex.submit()
            }
        }
    })

    $(document.body).on('updated_checkout', function (data) {
        if (!window.loadedPaymentFormAirwallex && $('input[name="payment_method"]:checked').val() == 'mecom_airwallex') {
            $('.woocommerce-checkout-payment').block({
                message: null,
                overlayCSS: {
                    background: '#fff',
                    opacity: 0.6
                }
            });
        }
    });
    /*
    event from proxy iframe
     */
    if (window.addEventListener) {
        window.addEventListener("message", listener);
    } else {
        window.attachEvent("onmessage", listener);
    }

    function blockOnSubmit(form) {
        var isBlocked = form.data('blockUI.isBlocked');

        if (1 !== isBlocked) {
            form.block({
                message: null,
                overlayCSS: {
                    background: '#fff',
                    opacity: 0.6
                }
            });
        }
    }

    function listener(event) {
        if (event.data === 'mecom-loadedPaymentFormAirwallex') {
            window.loadedPaymentFormAirwallex = true;
            $('.woocommerce-checkout-payment').unblock();
        }
        if ((typeof event.data === 'object') && event.data.name === 'mecom-airwallexCompletedCreditForm') {
            window.paymentFormCompletedAirwallex = event.data.value;
        }

        if ((typeof event.data === 'object') && event.data.name === 'mecom-airwallexConfirmPaymentResult') {
            var result = event.data.value;
            if (result.status === 'SUCCEEDED') {
                window.location.replace('/?cs_airwallex_complete_order=1&order_id=' + window.mecom_airwallex_order_id)
            } else {
                mecom_checkout_form_airwallex.removeClass('processing').unblock();
                checkout_error_airwallex('We cannot process your payment right now, please try another payment method.[35]');
            }
        }
        if ((typeof event.data === 'object') && event.data.name === 'mecom-airwallexConfirmPaymentException') {
            var result = event.data.value;
            $.get('/?cs_airwallex_fail_order=1&order_id=' + window.mecom_airwallex_order_id + 
                '&payment_intent_id=' + result.intent_id + 
                '&code=' + result.err.code + 
                '&message=' + result.err.message, {})
            mecom_checkout_form_airwallex.removeClass('processing').unblock();
            checkout_error_airwallex('We cannot process your payment right now, please try another payment method.[36]');
        }

        if ((typeof event.data === 'object') && event.data.name === 'mecom-errorSubmitPaymentAirwallex') {
            mecom_checkout_form_airwallex.removeClass('processing').unblock();
            checkout_error_airwallex('We cannot process your payment right now, please try another payment method.[3]');
        }
    }

    function checkout_error_airwallex(error_message) {
        $('.woocommerce-NoticeGroup-checkout, .woocommerce-error, .woocommerce-message').remove();
        mecom_checkout_form_airwallex.prepend('<div class="woocommerce-NoticeGroup woocommerce-NoticeGroup-checkout">' +
            '<ul class="woocommerce-error">' +
            '<li data-id="billing_last_name">' + error_message + '' +
            '</li>' +
            '</ul>' +
            '</div>'); // eslint-disable-line max-len
        mecom_checkout_form_airwallex.removeClass('processing').unblock();
        mecom_checkout_form_airwallex.find('.input-text, select, input:checkbox').trigger('validate').trigger('blur');
        var scrollElement = $('.woocommerce-NoticeGroup-updateOrderReview, .woocommerce-NoticeGroup-checkout');
        if (!scrollElement.length) {
            scrollElement = mecom_checkout_form_airwallex;
        }
        $.scroll_to_notices(scrollElement);
        $(document.body).trigger('checkout_error_airwallex', [error_message]);
    }

    function checkFieldValidatedAirwallex(target) {
        var isNotInvalid = !target.closest('.form-row').hasClass('woocommerce-invalid');
        var isNotEmpty = true;
        if (target.closest('.form-row').hasClass('validate-required')) {
            isNotEmpty = (typeof target.val() == 'string') ? target.val().length : false;
        }
        return isNotInvalid && isNotEmpty;
    }

    function validateFormCheckoutAirwallex() {
        return checkFieldValidatedAirwallex($('#billing_first_name')) &&
            checkFieldValidatedAirwallex($('#billing_last_name')) &&
            checkFieldValidatedAirwallex($('#billing_email')) &&
            checkFieldValidatedAirwallex($('#billing_city')) &&
            checkFieldValidatedAirwallex($('#billing_country')) &&
            checkFieldValidatedAirwallex($('#billing_postcode')) &&
            checkFieldValidatedAirwallex($('#billing_address_1')) &&
            checkFieldValidatedAirwallex($('#billing_address_2')) &&
            checkFieldValidatedAirwallex($('#billing_phone')) &&
            $('input[name="payment_method"]:checked').val() == 'mecom_airwallex';
    }

    window.addEventListener('hashchange', onHashChangeAirwallex);

    function onHashChangeAirwallex() {
        var partials = window.location.hash.match(/^#?cs-airwallex-confirm-pi-([^:::]+):::(.+):::(.+):::(.+)$/);
        if (!partials || 5 > partials.length) {
            return;
        }

        var paymentIntentId = partials[1];
        var intentClientSecret = partials[2];
        window.mecom_airwallex_order_id = partials[3];
        window.location.hash = '';
        loadPaymentProcessAirwallex();
        var street = mecomGetUserFieldAirwallex('address_1');
        if (mecomGetUserFieldAirwallex('address_2')) {
            street = ' ' + mecomGetUserFieldAirwallex('address_2')
        }
        $('#payment-airwallex-area')[0].contentWindow.postMessage({
            name: 'mecom-confirmPaymentIntentAirwallex',
            value: {
                payment_intent_id: paymentIntentId,
                payment_client_secret: intentClientSecret,
                billing: {
                    name: mecomGetUserFieldAirwallex('first_name') + ' ' + mecomGetUserFieldAirwallex('last_name'),
                    last_name: mecomGetUserFieldAirwallex('last_name'),
                    first_name: mecomGetUserFieldAirwallex('first_name'),
                    email: mecomGetUserFieldAirwallex('email'),
                    address: {
                        city: mecomGetUserFieldAirwallex('city'),
                        country_code: mecomGetUserFieldAirwallex('country'),
                        street: street,
                        postcode: mecomGetUserFieldAirwallex('postcode'),
                        state: mecomGetUserFieldAirwallex('state'),
                    },
                }
            }
        }, '*');
    }

    function mecomGetUserFieldAirwallex(fieldName) {
        if ($('#billing_' + fieldName).val() && $('#billing_' + fieldName).val().length > 0) {
            return $('#billing_' + fieldName).val();
        }
        return $('#shipping_' + fieldName).val()
    }
});
